#!/usr/bin/env bash

source bin/utilis/colors.sh

PACKAGE_NAME=$(node -p "require('./composer.json').name")

NAME=${PACKAGE_NAME##*/}
VENDOR=${PACKAGE_NAME%/${NAME}}
VERSION=$(git describe)

echo "${GREEN}${BOLD}> Building ${PACKAGE_NAME} from version ${VERSION}${RESET}"
ZIP_FILE="${VENDOR}-${NAME}-${VERSION}.zip"

zip -r ${ZIP_FILE} ./ -x@$(dirname "$0")/exclude-from-zip

# Make sure dist directory exists
[[ -d dist/ ]] || mkdir dist
mv ${ZIP_FILE} dist/${ZIP_FILE}
echo "${GREEN}${BOLD}> Created zip-file: dist/${ZIP_FILE}${RESET}"
